#include "gpio.hpp"

using namespace stm32f072xb;

Gpio::Gpio(volatile uint16_t& port, uint16_t pin, GpioState state)
    : _port(port), _pin(pin), _state(state) {
	setState(_state);
}

Gpio::~Gpio() {
	CLEAR_BIT(_port, (1 << _pin));
}

GpioState Gpio::getState() {
	return _state;
}

void Gpio::setState(GpioState state) {
	_state = state;
	(_state == GpioState::RESET) ? CLEAR_BIT(_port, (1 << _pin))
	                             : SET_BIT(_port, (1 << _pin));
}

void Gpio::toggle() {
	(_state == GpioState::RESET) ? setState(GpioState::SET)
	                             : setState(GpioState::RESET);
}
